import java.awt.*;
import java.util.*;

public class Phigsd extends Canvas{
	Dimension memDimension;
    Image memImage;
    Graphics memG;

    Color currlc = Color.white;
	Color currtc = Color.white;
	int currX, currY;
	int currfh, currfn;
	
	Vector vLine = new Vector();
	Vector vText = new Vector();
	Vector vArc = new Vector();
	
	public Phigsd() {
        super();
        setBackground(Color.black);
    }

    public void paint(Graphics g) {
        update(g);
    }

    public void update(Graphics g) {
        Dimension d = size();

        while((memG == null) || memImage == null ||
            (d.width != memDimension.width) ||
            (d.height != memDimension.height)) {
            memDimension = d;
            memImage = createImage(d.width, d.height);
            memG = memImage.getGraphics();
        }

        memG.setColor(getBackground());
        memG.fillRect(0, 0 , d.width, d.height);

        for(int i=0; i<vLine.size(); i++) {
        	Line l = (Line)vLine.elementAt(i);
        	l.paint(memG, d);
        }
        for(int i=0; i<vText.size(); i++) {
        	Text t = (Text)vText.elementAt(i);
        	t.paint(memG, d);
        }
        for(int i=0; i<vArc.size(); i++) {
        	Arc a = (Arc)vArc.elementAt(i);
        	a.paint(memG, d);
        }
        
        g.drawImage(memImage, 0, 0, this);
	}
    public void arc(int x, int y, int r, int aS, int aE) {
    	Arc a = new Arc(x, y, r, aS, aE, currlc);
    	vArc.addElement(a);
    	repaint();
    }
    
    public void circle(int x, int y, int r) {
    	int aS = 0;
    	int aE = 360;
    	arc(x, y, r, aS, aE);
    }
    
    public void line(int x1, int y1, int x2, int y2) {
    	Line l = new Line(x1, y1, x2, y2, currlc);
    	vLine.addElement(l);
    	repaint();
    }
    
    public void text(int x, int y, int len, String text) {
    	Text t = new Text(x, y, text, currtc, currfh, currfn);
    	vText.addElement(t);
    	repaint();
    }
    
    public void line_color(int red, int green, int blue) {
    	currlc = new Color(red, green, blue);
    }
    
    public void text_color(int red, int green, int blue) {
    	currtc = new Color(red, green, blue);
    }
    
    public void text_height(int fontHeight) {
    	currfh = fontHeight;
    }
    
    public void text_font(int fontName) {
    	currfn = fontName;
    }
    
    public void polyline(int x, int y) {
    	currX = x;
    	currY = y;
    }
    
    public void polyvertex(int x, int y) {
    	line(currX, currY, x, y);
    	currX = x;
    	currY = y;
    }

    public void clear() {
    	vLine.removeAllElements();
    	vText.removeAllElements();
    	vArc.removeAllElements();
    	repaint();
    }
}